import Component from '@ember/component';
import move from 'ember-animated/motions/move';
import { inject as service } from '@ember/service';
import { fadeIn } from 'ember-animated/motions/opacity';
import { fadeOut } from 'ember-animated/motions/opacity';
import { set } from '@ember/object';
import bezier from 'bezier-easing';

export default Component.extend({
  modal: service(),
  tagName: '',
  isActive: false,
  duration: 500,

  didInsertElement() {
    this.name && this.modal.registerModal(this);
  },

  willDestroyElement() {
    this.name && this.modal.destroyModal(this);
  },

  actions: {
    onOutsideClick() {
      this.close();
    },

    open() {
      this.open();
    },

    close() {
      this.close();
    }
  },

  * transitionModalOverlay({ insertedSprites, removedSprites }) { // eslint-disable-line require-yield
    for (let sprite of insertedSprites) {
      fadeIn(sprite, { easing: bezier(0.165, 0.84, 0.44, 1) });
    }

    for (let sprite of removedSprites) {
      fadeOut(sprite, { easing: bezier(0.165, 0.84, 0.44, 1) });
    }
  },

  * transitionModalContent({ insertedSprites, removedSprites }) { // eslint-disable-line require-yield

    for (let sprite of insertedSprites) {
      sprite.startTranslatedBy(0, 1000);
      move(sprite, { easing: bezier(0.165, 0.84, 0.44, 1) });
    }

    for (let sprite of removedSprites) {
      sprite.endTranslatedBy(0, 1000);
      move(sprite, { easing: bezier(0.165, 0.84, 0.44, 1) });
    }
  },

  open() {
    set(this, 'isActive', true);
    this.onOpen && this.onOpen();
  },

  close() {
    set(this, 'isActive', false);
  }
});

