import Service from '@ember/service';

export default Service.extend({
  init() {
    this._super(...arguments);
    this.modals = {};
  },

  registerModal(reference) {
    this.modals[reference.name] = reference;
  },

  destroyModal(reference) {
    this.modals[reference.name] = null;
  },

  open(name) {
    this.modals[name].open();
  },

  close(name) {
    this.modals[name].close();
  }
});

